//
// returns gamma, the angle in degrees between the scaled
// correction vector db and the scaled gradient vector g
//
#include "fit.h"

cdbl PI = 3.141592653589793238463;
cdbl degs_per_radian = 180.0/PI;

dbl gamma(dvec db, dvec g, int npar)
{
  int j;
  dbl gg;
  dbl dd;
  dbl gd;
  dbl cos_gam;
  dbl gamma;

  gg=dd=gd=0.0;                                    // ensure these are zero

  for (j=0;j<npar;j++) {
    gg += g[j]*g[j];
    dd += db[j]*db[j];
    gd += g[j]*db[j];
  }
  cos_gam = gd/sqrt(gg*dd);
  gamma = degs_per_radian*acos(cos_gam);                // gamma in degrees

  return gamma;
}
