//
// gets options from the command line
//

#include "config.h"                                  // for PACKAGE_VERSION
#include "fit.h"

extern int optind;

void get_opts(int argc, char** argv, opts& o)
{
  extern int opterr;
  int k;
  int opt_index=0;
  o.sigmas = no;
  o.verbose = no;
  string pgname = basename(argv[0]);

  if (pgname.rfind(".exe") != string::npos) {
    pgname.replace(pgname.find(".exe"),4,"");
  }

  static struct option long_options[] = {
    {"help", 0, 0, 'h'},
    {"version", 0, 0, 'v'},
    {"sigmas", 0, 0, 's'},
    {"verbose", 0, 0, 'V'},
    {0, 0, 0, 0}
  };

  opterr = yes;

  while ((k = getopt_long(argc, argv, "hvsV",
          long_options, &opt_index)) != -1 ) {

    switch(k) {
      case 'h':                                           // show help file
        prn_info(argv);
        exit(0);
        break;
      case 'v':                                      // show version number
        cerr << "\n  " << pgname
             << " version " << PACKAGE_VERSION << "\n\n";
        exit(0);
        break;
      case 's':                   // use if independent sigmas are provided
        o.sigmas = yes;
        break;
      case 'V':                        // show additional details in output
        o.verbose = yes;
        break;
      case '?':
        prn_usage(argv);
        exit(EXIT_FAILURE);
      default:
        prn_usage(argv);
        exit(EXIT_FAILURE);
    }
  }
}
