//
// these are Al Kelley's "graceful" versions.
//

#include "fit.h"

void gopen(ifstream& ifs, cstring fname)
{
  assert(ifs);
  assert(ifs.is_open() == false);
  ifs.open(fname.c_str());
  if (!ifs)
    err("cannot open ", fname);
}

void gopen(ofstream& ofs, cstring fname)
{
  ofs.open(fname.c_str());
  if (!ofs) {
    err("cannot open ", fname);
  }
}

// Here is the function prototype for strftime():
// size_t strftime(char* s, size_t max, const char* format, const struct tm* tm);

void gstrftime(string& s, cstring fmt, const struct tm* info)
{
  cint n = fmt.length() + 80;
  char buf[n];
  if (strftime(buf, sizeof(buf), fmt.c_str(), info)) {
    s = buf;
  }
  else {                // strftime returns 0 for unrecognized format chars
    time_t now = time(NULL);
    s = ctime(&now);                               // but ctime should work
  }
}

void gsystem(cstring cmd)
{
  if (system(cmd.c_str()) == -1) {
    err("call to system(", cmd, ") failed");
  }
}

