//
// Prints elements of vectors (dvecs or svecs) and matrices
// (dmats), along with a string (which must be supplied). The
// string is useful primarily for identifying the vector or the
// matrix.
//

#include "fit.h"

//
// Prints the gs string (which must be supplied) and the row of
// vector elements (doubles) on the screen.
//

void show(dvec g, string s)
{
  int j;
  int n = g.size();
  cint fw = 10;                                          // fw: field width

  cout << s << "\n";                                // prints the string gs
  for (j=0;j<n;j++)
    cout << right << showpoint << setw(fw) << g[j];
  cout << "\n";
}

//
// Prints the ss string (which must be supplied) and, in a
// column, the elements of the string vector s.
//

void show(svec s, string ss)
{
  int j;
  int n = s.size();
  cint fw = 20;                                          // fw: field width

  cout << ss << "\n";                              // prints the string ss.
  for (j=0;j<n;j++)
    cout << right << setw(fw) << s[j] << "\n";
}

//
// Prints the string s (which must be supplied) and the elements
// of a matrix a. The matrix a need not be square.
//

void show(dmat a, string s)
{
  int j,k;
  int n = a.size();                                       // number of rows
  int m = a[0].size();                                 // number of columns
  cint fw =8;                                            // fw: field width

  cout << s << "\n";                                     // prints string s
  cout.precision(2);
  for (j=0;j<n;j++) {
    for (k=0;k<m;k++) {
      cout << right << showpoint << setw(fw) << a[j][k];
    }
    cout << "\n";
  }
}
