//
// main for fitgauss
// November 19, 2014
//
#include "fit.h"
extern int optind;

int main(int argc, char** argv)
{
  dvec x;
  dvec y;
  dvec s;
  dvec b;
  misc m;
  opts o;
  ifstream ifs;

  get_opts(argc,argv,o);

  if (argc == optind + 1) {
    gopen(ifs, argv[optind]);                              // open datafile
    m.datafile = argv[optind];              // and store datafile name in m
  }
  else {
    prn_usage(argv);
    exit(EXIT_FAILURE);
  }

  get_data(ifs,x,y,s,b,o,m);
  ifs.close();

//
// Trouble-shooting code:
//
// If you have trouble, and want to check the code for your
// func() to see if it's properly written, uncomment the
// following lines (starting with "dvec p") and try running
//
// fit datafile
//
// where "datafile" is the name of your data file. You should
// then see, for your initial set of parameters, and x[0] (the
// first point of your data file):
//
// (a) the value returned by func(),
//
// (b) the string fs, provided by func(), that will be used in
//     making your graph,
//
// (c) the values of the p-vector (the partial derivatives
//     df/db[k]), and
//
// (d) the values of b[k], your initial set of parameters.
//
// All of these can be calculated by hand, and should make sense.
// If you leave only the "exit(1)" command commented out, the
// program will display the above, and continue, doing the
// calculations and showing a graph of the results. Otherwise the
// program will stop after displaying the above.
//
// dvec p;
// string fs;
// string ss;
// dbl f = func(x[0],b,p,fs,m);
// cout.precision(5);
// cout << "\n  from main, for x[0], f = " << f << "\n";
// cout << "  from main, fs = " << fs << "\n";
// ss = "  p-vector from main:";
// show(p,ss);
// ss = "\n  b-vector from main:";
// show(b,ss);
// cout << "\n\n";
// exit(1);

  calculate(x,y,s,b,m,o);
}
